import { Request, ResponseToolkit, ServerRegisterPluginObject, ServerRequestExtType, ServerRoute } from '@hapi/hapi';
import { AuthConfig, HttpConfig } from './types';
import { FrameworkConfig } from '../../shared/types';
export declare class HttpServerBoot {
    readonly config: HttpConfig;
    readonly frameworkConfig: FrameworkConfig;
    private app;
    constructor(config: HttpConfig, frameworkConfig: FrameworkConfig);
    get isRunning(): boolean;
    enableCors(config: any): void;
    close(): Promise<void>;
    start(): Promise<void>;
    bootControllersAndInterceptors(restControllersPath: string, restIntercerptorsPath?: string): Promise<void>;
    registerAuthStrategy(authConfig: AuthConfig): Promise<void>;
    registerPlugin(plugin: ServerRegisterPluginObject<any>): Promise<void>;
    registerRoute(route: ServerRoute): void;
    registerEventExtension(extensionConfig: ServerRequestExtType, callback: (request: Request, http: ResponseToolkit) => Promise<any>): Promise<void>;
}
